diff --git a/Makefile.in b/Makefile.in
index a2aaa90..4a30a97 100644
--- a/Makefile.in
+++ b/Makefile.in
@@ -83,7 +83,7 @@ DIST_COMMON = $(srcdir)/Makefile.in $(srcdir)/Makefile.am \
 	$(top_srcdir)/configure $(am__configure_deps) \
 	$(srcdir)/config.h.in $(srcdir)/libsixel.pc.in \
 	$(srcdir)/package.json.in.in ChangeLog NEWS compile \
-	config.guess config.sub install-sh missing ltmain.sh
+	config.guess config.sub depcomp install-sh missing ltmain.sh
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
 am__aclocal_m4_deps = $(top_srcdir)/m4/ax_gcc_func_attribute.m4 \
 	$(top_srcdir)/m4/ax_gcc_var_attribute.m4 \
diff --git a/converters/loader.c b/converters/loader.c
index 2198300..c18fcc1 100644
--- a/converters/loader.c
+++ b/converters/loader.c
@@ -390,7 +390,7 @@ load_png(unsigned char *buffer, int size,
             break;
 
         case 8:
-            if (ppalette && *pncolors <= 1 << 8) {
+            if (ppalette && reqcolors >= (1 << 8)) {
                 *pcomp = 1;
                 *pixelformat = PIXELFORMAT_G8;
             } else {
